/*
 *  Copyright (C) 2008  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */


#ifndef HC_XMPP_INTERNAL_H
#define HC_XMPP_INTERNAL_H

#include <gsasl.h>
#include <iksemel.h>
#include "xmpp.h"

enum
{
  NONE = 0x0,
  SUPPORTED = 0x1,
  OPTIONAL = 0x2,
  REQUIRED = 0x4,
  ENABLED = 0x8
};

struct _hc_xmpp_t
{
  char *server;
  char *user;
  char *password;
  iksparser *parser;
  Gsasl *sasl_ctx;
  Gsasl_session *sasl_session;
  int fd;
  int tls;
  int sasl;
  int status;
};

#endif
